use adventureworks2012
go
DBCC freeproccache
GO

-- Downloaded from http://www.SQLAuthority.com
-- Create Table and populate it.
CREATE TABLE TestTable (FirstCol VARCHAR(50),SecondCol INT)
INSERT INTO TestTable  
SELECT TOP 10000 'One', a.Object_ID
FROM sys.objects a
CROSS JOIN sys.objects b
UNION ALL
SELECT TOP 10 'Second', a.Object_ID
FROM sys.objects a
CROSS JOIN sys.objects b
GO
-- Create test SP.
CREATE PROCEDURE TESTSP
AS
SELECT FirstCol
FROM TestTable
WHERE FirstCol = 'One'
GO 
-- Execute Test SP
EXEC TESTSP
GO
SELECT cp.objtype AS PlanType,
       OBJECT_NAME(st.objectid,st.dbid) AS ObjectName,
       cp.refcounts AS ReferenceCounts,
       cp.usecounts AS UseCounts,  -- UseCount 1
       st.text AS SQLBatch,
       qp.query_plan AS QueryPlan -- Check Query Plan it has SCAN
FROM sys.dm_exec_cached_plans AS cp
CROSS APPLY sys.dm_exec_query_plan(cp.plan_handle) AS qp 
CROSS APPLY sys.dm_exec_sql_text(cp.plan_handle) AS st
WHERE  OBJECT_NAME(st.objectid,st.dbid) = 'TESTSP';
GO
-- Create Index
CREATE NONCLUSTERED INDEX [IX_TestTable] ON [dbo].[TestTable] 
(
	[FirstCol] ASC
)
GO
-- Execute SP
-- You will see that new index is now used
EXEC TESTSP
GO
SELECT cp.objtype AS PlanType,
       OBJECT_NAME(st.objectid,st.dbid) AS ObjectName,
       cp.refcounts AS ReferenceCounts,
       cp.usecounts AS UseCounts,  -- UseCount 2
       st.text AS SQLBatch,
       qp.query_plan AS QueryPlan -- Check Query Plan it has SEEK
FROM sys.dm_exec_cached_plans AS cp
CROSS APPLY sys.dm_exec_query_plan(cp.plan_handle) AS qp 
CROSS APPLY sys.dm_exec_sql_text(cp.plan_handle) AS st
WHERE  OBJECT_NAME(st.objectid,st.dbid) = 'TESTSP';
GO
-- Clean Up. Once cleaned up test can be ran again
USE [AdventureWorks2012]
GO
DROP INDEX [IX_TestTable] ON [dbo].[TestTable] WITH ( ONLINE = OFF )
GO
USE [AdventureWorks2012]
GO
DROP PROCEDURE [dbo].[TESTSP]
GO
USE [AdventureWorks2012]
GO
DROP TABLE [dbo].[TestTable]
GO

--------------------------------------------------------------------
-- The following query is useful in exploring the current plan cache contents:
SELECT cp.objtype AS PlanType,
       OBJECT_NAME(st.objectid,st.dbid) AS ObjectName,
       cp.refcounts AS ReferenceCounts,
       cp.usecounts AS UseCounts,
       st.text AS SQLBatch,
       qp.query_plan AS QueryPlan
FROM sys.dm_exec_cached_plans AS cp
CROSS APPLY sys.dm_exec_query_plan(cp.plan_handle) AS qp
CROSS APPLY sys.dm_exec_sql_text(cp.plan_handle) AS st;