USE adventureworks2012
go

SET NOCOUNT ON;

CREATE TABLE BillingInfo(
ID INT IDENTITY,
BillingDate DATETIME,
BillingAmt MONEY,
BillingDesc varchar(500));
 
DECLARE @I INT;
DECLARE @BD INT;
SET @I = 0;
WHILE @I < 1000000
BEGIN
  SET @I = @I + 1;
  SET @BD=CAST(RAND()*10000 AS INT)%3650;
  INSERT BillingInfo (BillingDate, BillingAmt)
  VALUES (DATEADD(DD,@BD,
    CAST('1999/01/01' AS DATETIME)),
    RAND()*5000);
END
 
ALTER TABLE BillingInfo
  ADD  CONSTRAINT [PK_BillingInfo_ID]
  PRIMARY KEY CLUSTERED (ID);
 
CREATE NONCLUSTERED INDEX IX_BillingDate
  ON dbo.BillingInfo(BillingDate);

GO
DROP PROC [dbo].[DisplayBillingInfo]
go
CREATE PROC [dbo].[DisplayBillingInfo]
  @BeginDate DATETIME,
  @EndDate DATETIME
AS

SELECT BillingDate, BillingAmt
  FROM BillingInfo
  WHERE BillingDate between @BeginDate AND @EndDate; 
go

/*CREATE PROC [dbo].[DisplayBillingInfo]
  @BeginDate DATETIME,
  @EndDate DATETIME
AS
DECLARE @StartDate DATETIME;
DECLARE @StopDate DATETIME;
SET @StartDate = @BeginDate;
SET @StopDate = @EndDate;
SELECT BillingDate, BillingAmt
  FROM BillingInfo
  WHERE BillingDate between @StartDate AND @StopDate; 
go*/

SELECT TOP 10 * FROM dbo.BillingInfo
select count(*) FROM dbo.BillingInfo

SET STATISTICS IO ON;
DBCC FREEPROCCACHE;
EXEC dbo.DisplayBillingInfo
  @BeginDate = '1999-01-01', 
  @EndDate  = '1999-12-31'; 
 
EXEC dbo.DisplayBillingInfo
  @BeginDate = '2005-01-01', 
  @EndDate  = '2005-01-03';

SET STATISTICS IO ON;
DBCC FREEPROCCACHE;
EXEC dbo.DisplayBillingInfo
  @BeginDate = '2005-01-01', 
  @EndDate  = '2005-01-03';
 
EXEC dbo.DisplayBillingInfo
  @BeginDate = '1999-01-01', 
  @EndDate  = '1999-12-31'; 